# tomoko2txt.rb  Ver.0.1
# umq̏vo͂umqeLXg`vA
# ʂ̃eLXgt@Cɐ؂oB
# Tats_y (http://www.binword.com/blog/)
# 2005/04/03

$KCODE="SJIS"
require 'jcode'
require 'iconv'
require 'fileutils'

if ARGV.size < 2 # p[^2菭Ȃ̓G[B
  print "usage: ruby tomoko2txt.rb Tomoko-Text OutputDirectory\n"
  exit 1
end

text = open(File.expand_path(ARGV.shift)) # eLXgt@CIuWFNg
out_dir = File.expand_path(ARGV.shift)
if not(FileTest.exist?(out_dir))
  FileUtils.mkdir_p(out_dir, :mode=>0755)
end

text.gets("#S\r\n") # ŏ#S܂ŋǂ

title = ""
body = ""
index = []
attached = []
filename = ""

dummy_number = 1

while line = text.gets
  if /^#T(.*)/ =~ line
    title = $1
  elsif /^#K(.*)/ =~ line
    index.push($1)
    elsif /^#F/ =~ line
      elsif /^#W(.*)/ =~ line
       elsif /^#X(.*)/ =~ line
        attached.push($1)
        elsif /^#E/ =~ line
          filename = title
          if filename == ""
            filename = "^CgȂ" + dummy_number.to_s
            dummy_number += 1
          end
          filename.gsub!(/^(\.)/, " .")
          filename.tr!("/", "^")
          filename.tr!(":", "F")
          File.open( File.join(out_dir, Iconv.conv("UTF-8", "SJIS", filename).to_s + ".txt"), "w") { |file|
            file.puts(body)
            if index != []
              file.puts("\n----------\n")
              index.each { |elem|
              file.puts("y" + elem.chomp + "z")
              }
            end
            if attached != []
              file.puts("\n----------\nYtt@C")
              attached.each { |elem|
              file.puts("y" + elem.chomp + "z")
              }
            end
          }
          title = ""
          body = ""
          index = []
          attached = []
          text.gets("#S\r\n")
          else
            body = body + line
  end
end

text.close
